Subject: Re: BMAC stuff - what I have

From: "Joseph P. Garcia" <[email-masked]>
Date: Sat, 10 Feb 2001 15:01:31 -0600

Kernel version: any (2.2.x - 2.4.x)

Symptoms: high speed transfers from a macintosh with a BMAC network device are limited to less than 100kB/s and often corrupted.  Systems known to have this are some Wallstreets and beige Desktops.  10/100 chips in Lombard are BMAC+ which do not seem to have the bug.  This is a hardware bug that exists in some releases of the chip, and only effects Tx packets.

Reproduction instructions: Open an FTP client to any system you have a potential 10Mbit transfer speed.  Transfering from the other computer will yeild high speeds, however transfering to the other system will reveal this problem.  This works with most all protocols i've seen.  This is also seen when on occation, SSH connections using scp or X-forwarding will close with a comment on connection quality/reliability.  something like that.

Explanation of problem: When there is a collision on the network, the BMAC chip will corrupt its Tx DMA buffer.  Proposed solution is to have only one Tx packet in DMA at a time, which the current driver seems to almost do.  Potential for more than one in transit seems to exist.  I beleive that there might be something else relevant to what causes the collisions.

Fixes: No known implementations in Linux.  MacOS and Darwin appear to have workarounds.

> (ie: http://www.geocrawler.com/archives/3/3/2000/10/0/4577176/
> http://www.geocrawler.com/archives/3/3/2000/2/0/3266218/ ).

good links

> Joseph Garcia said this bug had been listed and closed on sourceforge, but I
> can't find any record of that.

I don't recall saying that.  Might have been a miscommunication.  Some wallstreets aren't afflicted by the bug, so a 'works for me' may have been tagged on.  I had the opportunity to use one.  That's all I can say on that.

Attached are some files I recevied from Dan Malek on Jan 25.

I don't claim to be an expert on this.  I base my information on my (sometimes incorrect) interpretations of what I read and hear.  BenH has been much more helpful in explaining the problem.

Feel free to modify the above makings of a report before posting it.

I have tried my hand at hacking a solution together, but haven't gotten anywhere.

--
Joseph P. Garcia
http://www.execpc.com/~jpgarcia